"use strict";

function MyApp()
{
  var version = "v1.0";
  
  function setStatus(status)
  {
    $("#app>footer").text(status); 
  }
  
  function addTask()
  {
    var taskName = $("#new-task-name").val();
    if (taskName)
    {
      addTaskItem(taskName);
      // Reset the text field
      $("#new-task-name").val("").focus();
    }
  }
  
  function addTaskItem(text)
  {
    var taskTag = $("<li></li>");
    var buttonDelete = $("<button class='delete'>X</button>");
    var buttonMoveUp = $("<button class='move-up'>^</button>");
    var buttonMoveDown = $("<button class='move-up'>v</button>");
    var task = $("<span class='task-name'>" + text + "</span>");
          
    buttonDelete.click(function() {
      taskTag.remove();
    });
    
    buttonMoveUp.click(function() {
      taskTag.insertBefore(taskTag.prev());
    });
    
    buttonMoveDown.click(function() {
      taskTag.insertAfter(taskTag.next());
    });
    
    taskTag
    .append(task)
    .append(buttonDelete)
    .append(buttonMoveUp)
    .append(buttonMoveDown);
    
    $("#task-list").append(taskTag);
  }
  
  this.start = function()
  {
    $("#new-task-name").keypress(function(e) {
      if (e.which == 13) // Enter key
      {
        addTask();
        return false;
      }
    })
    .focus();

    $("#app>header").append(" "+version);
    setStatus("Ready");
  };
}

$(function() {
  window.app = new MyApp();
  window.app.start();
});
